use std::sync::LazyLock as Lazy;
use util::FxHashMap as HashMap;

pub static CLIPPY_SCORES: Lazy<HashMap<&'static str, f32>> = Lazy::new(|| {
    let expected_size = CLIPPY_SCORE_GROUPS.iter().map(|&g| g.len()).sum::<usize>();
    let mut out = HashMap::with_capacity_and_hasher(expected_size, Default::default());
    let all_lints = CLIPPY_SCORE_GROUPS.into_iter().rev().enumerate().flat_map(|(n, group)| {
        let base = (n as f64).powf(1.5) + n as f64;
        let scale = 1. / (group.len() as f64);
        group.iter().rev().copied().enumerate().map(move |(n, code)| {
            let score = (n as f64).mul_add(scale, base);
            debug_assert!(!code.contains("::"));
            (code, score as f32)
        })
    });
    for (code, score) in all_lints {
        let unique = out.insert(code, score).is_none();
        debug_assert!(unique, "{code}");
    }
    debug_assert_eq!(out.len(), expected_size);
    out
});

#[inline(never)]
#[must_use] pub fn score_for_clippy_code(code: &str, occurrences: u32) -> Option<f32> {
    let s = &*CLIPPY_SCORES;
    let code = code.strip_prefix("clippy::").unwrap_or(code);
    let base = s.get(code).or_else(move || s.get(code.split_once(' ')?.0))?;
    Some(0.125 * base * (8. + (occurrences.min(20) as f32).sqrt()))
}

const CLIPPY_SCORE_GROUPS: [&[&str]; 4] = [
    // Looks broken
    &[
        "dangling_pointers_from_temporaries",
        "rc_mutex",
        "static_mut_refs",
        "unused_io_amount",
        "uninit_assumed_init",
        "ambiguous_wide_pointer_comparisons",
        "transmute_ptr_to_ref",
        "redundant_allocation ref",
        "vec_box",
        "borrowed_box",
        "ptr_arg", // very noob mistake
        "temporary_cstring_as_ptr",
        "box_collection",
        "transmute_ptr_to_ptr",
        "borrow_as_ptr",
        "mut_from_ref",
        "not_unsafe_ptr_arg_deref",
        "out_of_bounds_indexing",
        "drop_bounds",
        "undropped_manually_drops",
        "order_dependent_trait_objects",
        "deprecated_where_clause_location",
        "incomplete_features",
        "uninit_vec",
        "toplevel_ref_arg",
        "needless_range_loop",
        "borrow_interior_mutable_const",
        "anonymous_parameters",
        "E0557",
        "E0793", // unaligned packed ref
        "non_fmt_panics",
        "redundant_allocation",
        "unconditional_recursion",
        "E0581",
        "needless_lifetimes a",
        "improper_ctypes",
        "invalid_reference_casting",
        "clashing_extern_declarations",
        "ellipsis_inclusive_range_patterns",
        "E0106",
        "partialeq_to_none",
        "for_loops_over_fallibles",
        "extra_unused_lifetimes",
        "dropping_copy_types",
        "deprecated uninit",
        "ptr_eq",
        "useless_deprecated",
        "unnecessary_unwrap",
        "zero_ptr",
        "dropping_references",
        "identity_op",
        "no_effect",
        "boxed_local",
        "array_into_iter",
        "enum_clike_unportable_variant",
        "cmp_owned",
        "suspicious_to_owned",
        "E0119",
        "recursive_format_impl",
        "improper_ctypes_definitions",
        "invalid_atomic_ordering",
        "meta_variable_misuse",
        "unnecessary_operation",
        "drop_non_drop",
        "forget_non_drop",
        "implicit_clone",
        "const_eval_mutable_ptr_in_final_value",
        "non_canonical_clone_impl",
        "to_string_in_format_args",
        "await_holding_loc",
        "await_holding_refcell_ref",
        "bare_trait_objects",
        "assigning_clones",
        "from_raw_with_void_ptr",
        "ref_binding_to_reference",
        "explicit_counter_loop",
        "needless_late_init",
        "read_zero_byte_vec",
        "size_of_ref",
        "needless_lifetimes",
        "invalid_value",
        "iter_count",
    ],

    // Could be bad
    &[
        "where_clauses_object_safety",
        "transmutes_expressible_as_ptr_casts",
        "E0512",
        "linkedlist",
        "type_alias_bounds",
        "deprecated try",
        "fn_address_comparisons",
        "suspicious_open_options",
        "let_underscore_lock",
        "rc_buffer",
        "useless_transmute",
        "noop_method_call",
        "forgetting_references",
        "iter_cloned_collect",
        "cmp_null",
        "deprecated std",
        "map_identity",
        "elided_lifetimes_in_associated_constant",
        "ok_expect",
        "unnecessary_map_on_constructor",
        "absolute_paths_not_starting_with_crate",
        "reversed_empty_ranges",
        "bind_instead_of_map",
        "invalid_doc_attributes",
        "op_ref",
        "extra_unused_type_parameters",
        "manual_flatten",
        "format_in_format_args",
        "private_interfaces",
        "unreachable_patterns",
        "chars_next_cmp",
        "ptr_offset_with_cast",
        "large_stack_arrays",
        "while_let_loop",
        "forgetting_copy_types",
        "unused_must_use",
        "needless_bool_assign",
        "needless_return_with_question_mark",
        "needless_bool",
        "fn_to_numeric_cast_any",
        "into_iter_on_ref",
        "nonstandard_macro_braces",
        "to_string_trait_impl",
        "float_cmp",
        "erasing_op",
        "while_immutable_condition",
        "write_with_newline",
        "mem_forget",
        "E0373",
        "from_str_radix_10",
        "unused_must_use fut",
        "crosspointer_transmute",
        "transmute_int_to_bool",
        "needless_collect",
        "slow_vector_initialization",
        "bytes_count_to_len",
        "useless_ptr_null_checks",
        "string_to_string",
        "transmute_undefined_repr",
        "macro_metavars_in_unsafe",
        "soft_unstable",
        "ptr_arg mutvec",
        "deprecated",
        "legacy_derive_helpers",
        "special_module_name",
        "suspicious_double_ref_op",
        "needless_pass_by_ref_mut",
        "duplicate_mod",
        "named_arguments_used_positionally",
        "await_holding_lock",
        "mutex_integer",
        "stable_features",
        "bad_bit_mask",
        "self_assignment",
        "unnecessary_to_owned",
        "as_ptr_cast_mut",
        "unwrap_in_result",
        "unused_peekable",
    ],
    // Suspicious
    &[
        "drain_collect",
        "iter_on_empty_collections",
        "nonstandard_macro_braces",
        "duplicated_attributes",
        "large_stack_frames",
        "useless_let_if_seq",
        "unused_must_use raw",
        "ptr_arg mut",
        "verbose_file_reads",
        "unnecessary_self_imports",
        "unused_result_ok",
        "trailing_empty_array",
        "redundant_clone",
        "mem_replace_with_uninit",
        "transmute_int_to_char",
        "repeat_once",
        "type_id_on_box",
        "vec_init_then_push",
        "double_must_use",
        "pathbuf_init_then_push",
        "almost_swapped",
        "transmute_float_to_int",
        "is_digit_ascii_radix",
        "single_range_in_vec_init",
        "suspicious_command_arg_space",
        "declare_interior_mutable_const",
        "useless_format",
        "let_and_return",
        "transmute_bytes_to_str",
        "transmute_int_to_float",
        "arc_with_non_send_sync",
        "redundant_as_str",
        "match_str_case_mismatch",
        "if_same_then_else",
        "unused_comparisons",
        "map_collect_result_unit",
        "search_is_some",
        "cast_ptr_alignment",
        "redundant_slicing",
        "mut_mutex_lock",
        "unnecessary_owned_empty_strings",
        "E0392",
        "dyn_drop",
        "module_inception",
        "deref_addrof",
        "let_unit_value",
        "invalid_regex",
        "manual_ok_or",
        "misrefactored_assign_op",
        "manual_memcpy",
        "wildcard_in_or_patterns",
        "unsafe_derive_deserialize",
        "approx_constant",
        "chars_last_cmp",
        "misnamed_getters",
        "size_of_in_element_count",
        "print_literal",
        "permissions_set_readonly_false",
        "suspicious_assignment_formatting",
        "single_component_path_imports",
        "transmute_num_to_bytes",
        "disallowed_names",
        "needless_borrowed_reference",
        "option_filter_map",
        "comparison_to_empty",
        "ambiguous_glob_reexports",
        "unused_allocation",
        "unused_extern_crates",
        "unused_assignments",
        "needless_borrow",
        "useless_attribute",
        "unnecessary_cast",
        "redundant_guards",
        "empty_loop",
        "join_absolute_paths",
        "never_loop",
        "ref_option_ref",
        "needless_match",
        "unused_enumerate_index",
        "iter_nth_zero",
        "E0782",
        "while_true",
        "suspicious_doc_comments",
        "empty_enum_variants_with_brackets",
        "lines_filter_map_ok",
        "no_mangle_with_rust_abi",
        "suspicious_else_formatting",
        "unreachable_code",
        "expect_fun_call",
        "iter_nth",
        "suspicious_arithmetic_impl",
        "hidden_glob_reexports",
        "mut_range_bound",
        "redundant_async_block",
        "serde_api_misuse",
        "impl_hash_borrow_with_str_and_bytes",
        "result_unit_err",
        "needless_if",
        "invalid_nan_comparisons",
        "blocks_in_conditions",
        "mem_replace_option_with_none",
        "needless_borrows_for_generic_args",
        "needless_arbitrary_self_type",
        "fn_params_excessive_bools",
        "manual_split_once",
        "needless_update",
        "clone_on_copy",
        "match_result_ok",
        "let_underscore_future",
        "filter_map_identity",
        "partialeq_ne_impl",
        "maybe_misused_cfg",
        "redundant_pattern",
        "trivial_regex",
        "box_default",
        "panicking_unwrap",
        "just_underscores_and_digits",
        "unnecessary_join",
        "question_mark",
        "needless_question_mark",
        "unnecessary_box_returns",
        "precedence",
        "non_snake_case",
        "manual_retain",
        "unused_mut",
        "iter_overeager_cloned",
        "get_last_with_len",
        "println_empty_string",
        "crate_in_macro_def",
        "manual_swap",
        "useless_conversion",
        "flat_map_identity",
        "char_lit_as_u8",
        "neg_cmp_op_on_partial_ord",
        "map_entry",
        "suspicious_splitn",
        "assign_op_pattern",
        "manual_instant_elapsed",
        "map_flatten",
        "should_implement_trait",
        "while_let_on_iterator",
        "manual_non_exhaustive",
        "single_char_add_str",
        "path_buf_push_overwrite",
        "zero_divided_by_zero",
        "pub_underscore_fields",
        "result_filter_map",
        "manual_unwrap_or",
        "manual_while_let_some",
        "inconsistent_digit_grouping",
        "single_match",
        "ignored_unit_patterns",
        "suspicious_op_assign_impl",
        "option_map_unit_fn",
        "manual_is_ascii_check",
        "large_enum_variant",
        "derivable_impls",
        "extend_with_drain",
        "result_large_err",
        "filter_next",
        "format_collect",
        "bool_comparison",
        "ineffective_open_options",
        "manual_find",
        "unnecessary_mut_passed",
        "from_over_into",
        "new_ret_no_self",
        "needless_return",
        "mutable_key_type",
        "single_element_loop",
        "assertions_on_constants",
        "unnecessary_filter_map",
        "format_push_string",
        "double_comparisons",
        "write_literal",
        "field_reassign_with_default",
        "nonminimal_bool",
        "implicit_saturating_sub",
        "match_on_vec_items",
        "little_endian_bytes",
        "shadow_unrelated",
        "iter_filter_is_some",
        "unit_cmp",
        "absurd_extreme_comparisons",
        "manual_is_infinite",
        "manual_map",
        "comparison_chain",
        "iter_kv_map",
        "manual_saturating_arithmetic",
        "unnecessary_lazy_evaluations",
        "string_extend_chars",
        "swap_ptr_to_ref",
        "inherent_to_string",
        "unusual_byte_groupings",
        "borrow_deref_ref",
        "large_digit_groups",
        "non_canonical_partial_ord_impl",
        "break_with_label_and_loop",
        "ambiguous_associated_items",
        "derived_hash_with_manual_eq",
        "E0404",
        "arithmetic_overflow",
        "confusable_idents",
        "trim_split_whitespace",
        "equatable_if_let",
        "deprecated_clippy_cfg_attr",
        "same_item_push",
        "derive_ord_xor_partial_ord",
        "manual_str_repeat",
        "almost_complete_range",
        "unnecessary_literal_unwrap",
        "empty_docs",
        "manual_assert",
        "unnecessary_sort_by",
        "missing_spin_loop",
        "inherent_to_string_shadow_display",
        "match_wild_err_arm",
        "iter_not_returning_iterator",
        "variant_size_differences",
        "mut_mut",
        "option_map_or_err_ok",
        "mixed_attributes_style",
        "unnecessary_fallible_conversions",
        "macro_use_extern_crate",
        "internal_features",
        "non_minimal_cfg",
        "too_many_arguments",
        "explicit_write",
        "manual_async_fn",
        "unwrap_used",
        "match_bool",
        "int_plus_one",
        "eq_op",
        "too_many_lines",
        "useless_asref",
        "non_octal_unix_permissions",
        "mem_replace_with_default",
        "explicit_deref_methods",
        "option_map_or_none",
        "reserve_after_initialization",
        "filter_map_bool_then",
        "cast_abs_to_unsigned",
        "missing_transmute_annotations",
        "overly_complex_bool_expr",
        "many_single_char_names",
        "ambiguous_glob_imports",
        "type_complexity",
        "tyvar_behind_raw_pointer",
        "explicit_auto_deref",
        "deprecated_cfg_attr",
        "stable_sort_primitive",
        "unused_macro_rules",
        "redundant_lifetimes",
        "seek_from_current",
        "inefficient_to_string",
        "naive_bytecount",
        "manual_strip",
        "unnecessary_get_then_check",
        "mismatching_type_param_order",
        "ifs_same_cond",
        "unicode_not_nfc",
        "implied_bounds_in_impls",
        "elided_lifetimes_in_paths",
        "str_split_at_newline",
        "option_option",
        "trivially_copy_pass_by_ref",
        "map_clone",
        "option_as_ref_deref",
        "multiple_bound_locations",
        "print_in_format_impl",
        "needless_bitwise_bool",
        "range_plus_one",
        "wrong_self_convention",
        "explicit_into_iter_loop",
        "option_as_ref_cloned",
        "match_wildcard_for_single_variants",
        "semicolon_in_expressions_from_macros",
        "zero_sized_map_values",
        "large_futures",
        "large_types_passed_by_value",
        "deprecated_semver",
        "verbose_bit_mask",
        "neg_multiply",
        "manual_slice_size_calculation",
        "filter_map_next",
        "unstable_name_collisions",
        "useless_vec",
        "manual_filter",
        "ptr_as_ptr",
        "E0699",
        "explicit_iter_loop",
        "match_single_binding",
        "needless_option_as_deref",
        "invalid_upcast_comparisons",
        "range_minus_one",
        "multiple_crate_versions",
        "unnecessary_wraps",
        "iter_filter_is_ok",
        "redundant_at_rest_pattern",
        "manual_unwrap_or_default",
        "checked_conversions",
        "suspicious_map",
        "panic_in_result_fn",
        "mixed_case_hex_literals",
        "manual_next_back",
        "legacy_numeric_constants",
        "expl_impl_clone_on_copy",
        "no_effect_underscore_binding",
        "needless_pass_by_value",
        "unit_arg",
        "test_attr_in_doctest",
        "single_match_else",
        "or_then_unwrap",
        "match_ref_pats",
        "large_const_arrays",
        "unnecessary_find_map",
        "unit_hash",
        "redundant_type_annotations",
        "manual_find_map",
        "unused_attributes",
        "E0554", // nightly
        "doc_link_with_quotes",
        "redundant_semicolons",
        "private_macro_use",
        "asm_sub_register",
        "single_char_pattern",
        "unstable_features",
        "E0635",
        "E0658",
        "string_slice",
        "string_add",
        "used_underscore_binding",
        "bytes_nth",
        "debug_assert_with_mut_call",
        "infallible_destructuring_match",
        "missing_asserts_for_indexing",
        "no_effect_replace",
        "collection_is_never_read",
        "struct_excessive_bools",
        "cognitive_complexity",
        "renamed_and_removed_lints",
        "deprecated err",
        "unused_imports std",
        "unused_must_use res",
        "unused_variables assign",
        "E0277",
        "E0500",
        "E0740",
        "trivial_casts", // has false positives ;(
        "iter_next_slice",
        "unused_braces",
        "non_upper_case_globals",
        "iter_skip_next",
        "trivial_casts dyn",
        "negative_feature_names",
        "unused_doc_comments",
        "diverging_sub_expression",
        "fallible_impl_from",
        "suboptimal_flops",
        "suspicious_operation_groupings",
        "unnameable_types",
        "rust_2024_incompatible_pat",
    ],
    // harmless
    &[
        "unknown_lints",
        "deref_by_slicing",
        "redundant_feature_names",
        "branches_sharing_code",
        "cargo_common_metadata",
        "unnecessary_cast integer",
        "unnecessary_cast float",
        "use_self",
        "dead_code",
        "future_not_send",
        "trivial_casts ffi",
        "non_snake_case _",
        "lib.rs builder",
        "unused_crate_dependencies", // would be great, but it's buggy
        "shadow_reuse",
        "shadow_same",
        "let_with_type_underscore",
        "type_repetition_in_bounds",
        "multiple_unsafe_ops_per_block",
        "or_fun_call",
        "undocumented_unsafe_blocks",
        "semicolon_outside_block",
        "pub_with_shorthand",
        "self_named_module_files",
        "keyword_idents",
        "unsupported_calling_conventions",
        "for_kv_map",
        "invisible_characters",
        "needless_pub_self",
        "unwrap_or_default",
        "get_first",
        "manual_try_fold",
        "collapsible_match",
        "unused_unit",
        "needless_continue",
        "copy_iterator",
        "similar_names",
        "init_numbered_fields",
        "unexpected_cfgs",
        "unsafe_code trait",
        "unit_bindings",
        "flat_map_option",
        "redundant_pattern_matching",
        "unused_imports",
        "option_if_let_else",
        "absolute_paths",
        "match_overlapping_arm",
        "new_without_default",
        "match_as_ref",
        "E0283",
        "redundant_static_lifetimes",
        "needless_else",
        "duration_subsec",
        "unreachable_pub",
        "wildcard_imports",
        "manual_bits",
        "only_used_in_recursion",
        "non_camel_case_types",
        "unused_macros",
        "default_constructed_unit_structs",
        "enum_variant_names",
        "must_use_candidate",
        "missing_panics_doc",
        "redundant_locals",
        "uninlined_format_arg",
        "needless_raw_string_hashess",
        "double_parens",
        "redundant_closure_call",
        "writeln_empty_string",
        "std_instead_of_core",
        "bool_assert_comparison",
        "zero_prefixed_literal",
        "unused_async",
        "inline_fn_without_body",
        "redundant_field_names",
        "upper_case_acronyms",
        "pub_use",
        "unused_parens",
        "needless_doctest_main",
        "missing_docs_in_private_items",
        "four_forward_slashes",
        "needless_splitn",
        "unused_variables",
        "single_call_fn",
        "self_named_constructors",
        "unused_unsafe",
        "unsafe_code",
        "return_self_not_must_use",
        "trivial_numeric_casts",
        "derive_partial_eq_without_eq",
        "redundant_closure",
        "tabs_in_doc_comments",
        "E0282",
        "print_with_newline",
        "manual_let_else",
        "len_zero",
        "unnecessary_fold",
        "module_name_repetitions",
        "items_after_statements",
        "min_ident_chars",
        "semicolon_if_nothing_returned",
        "excessive_precision",
        "redundant_closure_for_method_calls",
        "unused_self",
        "cloned_instead_of_copied",
        "unnecessary_result_map_or_else",
        "redundant_else",
        "match_like_matches_macro",
        "manual_string_new",
        "missing_docs",
        "significant_drop_tightening",
        "skip_while_next",
        "std_instead_of_alloc",
        "missing_const_for_fn",
        "needless_for_each",
        "map_unwrap_or",
        "case_sensitive_file_extension_comparisons",
        "manual_clamp",
        "manual_range_patterns",
        "cast_lossless",
        "from_iter_instead_of_collect",
        "implicit_hasher",
        "inconsistent_struct_constructor",
        "collapsible_if",
        "enum_glob_use",
        "iter_without_into_iter",
        "doc_lazy_continuation",
        "struct_field_names",
        "same_functions_in_if_condition",
        "unnested_or_patterns",
        "unsafe_code method",
        "unsafe_code block",
        "unsafe_code declmethod",
        "keyword_idents_2024",
        "collapsible_else_if",
        "redundant_pub_crate",
        "match_same_arms",
        "question_mark_used",
        "into_iter_without_iter",
        "doc_markdown",
        "too_long_first_doc_paragraph",
        "missing_errors_doc",
        "if_not_else",
        "bool_to_int_with_if",
        "missing_copy_implementations",
        "single_char_lifetime_names",
        "needless_parens_on_range_literals",
        "missing_inline_in_public_items",
        "cast_possible_wrap",
        "unchecked_duration_subtraction",
        "unused_qualifications",
        "print_stdout",
        "missing_fields_in_debug",
        "cast_possible_truncation",
        "cast_sign_loss",
        "maybe_infinite_iter",
        "string_add_assign",
        "integer_division",
        "cast_precision_loss",
        "uninlined_format_args",
        "missing_safety_doc",
        "index_refutable_slice",
        "needless_raw_string_hashes",
        "manual_range_contains",
        "iter_over_hash_type",
        "lint_groups_priority",
        "pub_without_shorthand",
        "as_conversions",
        "unsafe_op_in_unsafe_fn",
        "use_debug",
        "incompatible_msrv",
        "unused_lifetimes", // has false positives
        "single_use_lifetimes", // has false positives
        "E0433", // windows
        "E0455", // mac
        "E0599",
        "future_not_send",
        "too_long_first_doc_paragraph",
        "empty_line_after_outer_attr",
        "impl_trait_overcaptures", // too new
        "non_send_fields_in_send_ty", // controversial
        "unnecessary_struct_initialization", // buggy?
    ],
];
